﻿using System;
using System.Collections.Generic;
//using System.Linq;
using System.Text;
using PRoCon.Core;
using PRoCon.Core.Plugin;
using PRoCon.Core.Players;

namespace PRoConEvents
{

     public class Seeder
    {
        public string soldierName;
        public int teamid;
        private bool active_flag = false;
        private bool onlineStatus = false;
        private double current_score = 0;
        private double previous_score = 0;
        private DateTime time_of_most_recent_score_increase = DateTime.Now.AddHours(-1.00);

        public void updateScore(double newscore)
        {
            if (newscore > current_score)
            {
                time_of_most_recent_score_increase = DateTime.Now;
            }
            previous_score = current_score;
            current_score = newscore;
        }
        public DateTime getTimeOfLastScoreIncrease() { return time_of_most_recent_score_increase; }
        public double getMinutesSinceLastScoreIncrease()
        {
            TimeSpan dt = DateTime.Now - time_of_most_recent_score_increase;
            return dt.TotalMinutes;
        }
        public void setActive() { active_flag = true; }
        public void setInactive() { active_flag = false; }
        public bool checkIsActive() { return active_flag; }
        public bool checkIsOnline() { return onlineStatus; }
        public void setOnline() { onlineStatus = true; }
        public void setOffline() { onlineStatus = false; }


    }

    public class BalanceServerSeeders : PRoConPluginAPI, IPRoConPluginInterface
    {
        private List<string> seederNames;
        private List<Seeder> SeederList;
        private string curr_gameMode;
        private bool rush_mode_flag;
        private bool pluginenabled = false;
        private double time_since_score = 5;
        private int debugPrintLevel = 1;
        private int balanceMethod = 1;
        private int team1Score = 0;
        private int team2Score = 0;
        private int team1count = 0;
        private int team2count = 0;
        private int team1RealPlayerCount = 0;
        private int team2RealPlayerCount = 0;
        private int team1InactiveSeederCount = 0;
        private int team2InactiveSeederCount = 0;
        private int team1_minus_team2_inactiveSeederCount = 0;
        private int team1_minus_team2_realPlayerCount = 0;
        private int team1_minus_team2_score = 0;
        public BalanceServerSeeders()
        {
            this.seederNames = new List<string>();
            this.seederNames.Add("SeederSoldier1");
            this.seederNames.Add("SeederSoldier2");
            this.SeederList = new List<Seeder>();
        }
        public string GetPluginName()
        {
            return "BalanceServerSeeders";
        }
        public string GetPluginVersion()
        {
            return "2.0.2.1";
        }
        public string GetPluginAuthor()
        {
            return "Flyswamper";
        }
        public string GetPluginWebsite()
        {
            return "www.phogue.net/forumvb/showthread.php?3992-BF3-BalanceServerSeeders(1-0-1-5-21-Apr-2012)-Distribute-server-seeding-players>BalanceServerSeeders";
        }
        public string GetPluginDescription()
        {
            return @"
<h2>Description</h2>
<p>Balances pre-designated server-seeding accounts between Team 1 and Team2</p>


<h2>Settings</h2>
<blockquote><h4>Debug_Level  &lt;value (0-5)&gt;</h4>This will increase/decrease the amount of information that gets written to the plugin console window.  A value of 0 (zero) should eliminate all output from the plugin.  A value of 5 provides maximum output.</blockquote>

<blockquote><h4>Method for balancing  &lt;value (1-2)&gt;</h4>This will select the balancing method. A value of 1 uses the playercount to decide where to put any extra seeders.  A value of 2 uses the team scores to decide where to put an extra seeder.</blockquote>

<blockquote><h4>Time_Since_Score  &lt;minutes&gt;</h4>If a server-seeder has scored within this time period, the player will be considered active and will not be subjected to balancing with other seeder accounts that are currently on the server.</blockquote>

<blockquote><h4>Seeders  &lt;soldiernames one per line&gt;</h4>Enter the soldiernames (without clan tags)for each of the accounts you wish to designate as a seeder that this plugin should balance/manage.</blockquote>



<h2>Development</h2>
<h3>Changelog</h3>
<h4>Version 2.0.2.1   8-Aug-2012</h4>
<ul>
<li>Revise code to eliminate loops.  Only move one seeder per check.  Plugin will take longer to acheive balance but less risk of endless loop coding errors</li>
</ul>

<h4>Version 2.0.2.0   5-Aug-2012</h4>
<ul>
<li>This is a significant rewrite of code and logic and (unfortunately) I can't test it myself.  Likely to have bugs is high!</li>
<li>Added ability for user to select balancing based on two methods.  Player or Score count</li>
</ul>

<h4>Version 2.0.1.1   15-July-2012</h4>
<ul>
<li>Minor bugfix/change.  Adjusted loop/logic that executes the player move to another team.</li>
<li>Added more diagnostic output (use level 5 to see it all)</li>
</ul>

<h4>Version 2.0.1.0   14-July-2012</h4>
<ul>
<li>Revised code so that it would detect whether rush mode is active.</li>
<li>If Rush mode is active and an odd number of inactive seeders are online, the extra seeder should now be forced to the defenders team</li>
<li>If mode is NOT Rush and an odd number of inactive seeders are online, the extra seeder should now be forced to team 1. This *should* help keep non-seeder player counts more balanced when the server population is low.</li>
</ul>

<h4>Version 2.0.0.4   28-April-2012</h4>
<ul>
<li>Bugfix - plugin was remembering seeders MAX score instead of last score.</li>
</ul>

<h4>Version 2.0.0.3   28-April-2012</h4>
<ul>
<li>Simplify code and make it easier to follow (but still same basic logic)</li>
<li>Improve the formatting of the debug output to the plugin console window</li>
</ul>

<h4>Version 2.0.0.2   21-April-2012</h4>
<ul>
<li>Bug fix related to player not detected as going offline</li>
</ul>


<h4>Version 2.0.0.1   21-April-2012</h4>
<ul>
<li>Completely re-coded the logic to properly handle active/idle detection better</li>
<li>Improved the details info sheet within the plugin (what you are reading now)</li>
</ul>

<h4>Versions 1.0.1.3,  1.0.1.4,  and 1.0.1.5   xx-March-2012</h4>
<ul>
<li>These were failed attempts at quick-fixing the code to use a time-since last score to detect if a seeder was active or not.</li>
</ul>


<h4>Version 1.0.1.2   11-March-2012</h4>
<ul>
<li>Renamed plugin to BalanceServerSeeders because it does a much better job of describing what the plugin does!</li>
<li>Fix a minor typo</li>
</ul>

<h4>Version 1.0.1.1    7-March-2012</h4>
<ul>
<li>Fix a couple of issues where tet written to plugin console log was incorrect.  Did not affection functionality</li>
<li>Fix a minor typo</li>
</ul>

<h4>Version 1.0.0.6    6-March-2012</h4>
<ul>
<li>Make sure full player list is received before taking action</li>
<li>Implemented code suggestions from stealth (thanks!)</li>
<li>Added debug-output levels</li>
<li>Added logic to consider seeder as active if he has non-zero score</li>
<li>Changed plugin name from CKeepCampersApart to CKeepSeedersApart</li>
</ul>


<h3>To-do</h3>
<ul>
<li>Add logic/controls that will allow criteria for when/if seeders should be kicked from the server (e.g. when server is near-full)</li>
<li>Others?</li>
</ul>

";

        }
        public void OnPluginEnable()
        {
            this.pluginenabled = true;
            this.ExecuteCommand("procon.protected.pluginconsole.write", "^bBalanceServerSeeders ^2Enabled!");
        }
        public void OnPluginDisable()
        {
            this.pluginenabled = false;
            this.ExecuteCommand("procon.protected.pluginconsole.write", "^bBalanceServerSeeders ^1Disabled =(");
        }
        public void OnPluginLoaded(string strHostName, string strPort, string strPRoConVersion)
        {
            this.ExecuteCommand("procon.protected.pluginconsole.write", "^bBalanceServerSeeders ^2Loaded!");
            this.RegisterEvents(this.GetType().Name, "OnPluginLoaded",
                                                    "OnPlayerJoin",
                                                    "OnListPlayers",
                                                    "OnPlayerLeft",
                                                    "OnServerInfo"
                                                    );
            rush_mode_flag = false;     // default value set when loaded
        }
        public List<CPluginVariable> GetDisplayPluginVariables()
        {

            List<CPluginVariable> lstReturn = new List<CPluginVariable>();

            lstReturn.Add(new CPluginVariable("Seeders (one per line)|Seeders", typeof(string[]), this.seederNames.ToArray()));
            lstReturn.Add(new CPluginVariable("Debug (0-5 higher is more info)|debug_level", debugPrintLevel.GetType(), debugPrintLevel));
            lstReturn.Add(new CPluginVariable("Number of minutes since last score change for seeder to be considered AFK|time_since_score", this.time_since_score.GetType(), this.time_since_score));
            lstReturn.Add(new CPluginVariable("Method for balancing (1-2)|balanceMethod",balanceMethod.GetType(), balanceMethod));
            return lstReturn;
        }
        public List<CPluginVariable> GetPluginVariables()
        {
            List<CPluginVariable> lstReturn = new List<CPluginVariable>();

            lstReturn.Add(new CPluginVariable("Seeders", typeof(string[]), this.seederNames.ToArray()));
            lstReturn.Add(new CPluginVariable("debug_level", this.debugPrintLevel.GetType(), this.debugPrintLevel));
            lstReturn.Add(new CPluginVariable("time_since_score", this.time_since_score.GetType(), this.time_since_score));
            lstReturn.Add(new CPluginVariable("balanceMethod", this.balanceMethod.GetType(), this.balanceMethod));
            return lstReturn;
        }
        private void rebuild_SeederList_detailed()
        {
            // wipes out the seeder list and re-creates it, used when user changes inputs 
            SeederList.Clear();
            for (int i = 0; i < seederNames.Count; i++)
            {
                Seeder newSeeder = new Seeder();
                newSeeder.soldierName = seederNames[i];
                newSeeder.setInactive();
                newSeeder.teamid = 0;
                newSeeder.setOffline();
                newSeeder.updateScore(0);
                SeederList.Add(newSeeder);
            }
        }
        private int countIdleOnlineSeeders(int team_num)
        {
            // return the number of idle and online seeders on the specified team
            int idleonlinecount = 0;

            for (int ndxSeeder = 0; ndxSeeder < SeederList.Count; ndxSeeder++)
            {
                bool match_flag = true;     // assume it's a match, check and correct if not
                if (SeederList[ndxSeeder].checkIsActive() == false) { match_flag = false; }            // don't count if not active
                if (SeederList[ndxSeeder].checkIsOnline() == false) { match_flag = false; }   // don't count if not online
                if (SeederList[ndxSeeder].teamid != team_num) { match_flag = false; }       // don't count if not the correct team

                if (match_flag) { idleonlinecount++; }

            }
            return idleonlinecount;
        }

        public void SetPluginVariable(string strVariable, string strValue)
        {
            int result = 0;
            if (strVariable.CompareTo("Seeders") == 0)
            {
                this.seederNames = new List<string>(CPluginVariable.DecodeStringArray(strValue));
                rebuild_SeederList_detailed();

            }
            if ((strVariable.CompareTo("debug_level") == 0) && int.TryParse(strValue, out result) == true)
            {
                writeMsgToPluginConsole(1, string.Format("Setting debug_level to {0}", result));
                debugPrintLevel = result;
            }
            double resultTime = 5;
            if ((strVariable.CompareTo("time_since_score") == 0) && double.TryParse(strValue, out resultTime) == true)
            {
                writeMsgToPluginConsole(1, string.Format("Setting time_since_score to {0}", resultTime));
                this.time_since_score = resultTime;
            }
            if ((strVariable.CompareTo("balanceMethod") == 0) && int.TryParse(strValue, out result) == true)
            {
                writeMsgToPluginConsole(1, string.Format("Setting balanceMethod to {0}", result));
                this.balanceMethod = result;
            }
            
        }
        public void OnPlayerJoin(string strSoldierName)
        {
            writeMsgToPluginConsole(2, string.Format("{0} joined", strSoldierName.ToString()));
            for (int ndx = 0; ndx < SeederList.Count; ndx++)
            {
                if (string.Compare(SeederList[ndx].soldierName, strSoldierName) == 0)
                {
                    SeederList[ndx].setOnline();
                    writeMsgToPluginConsole(3, string.Format("Seeder {0} has joined the server", SeederList[ndx].soldierName));
                }
            }

        }
        public void OnPlayerLeft(CPlayerInfo playerInfo)
        {
            // need to remove seeder from online status if this is a seeder leaving
            for (int ndx = 0; ndx < SeederList.Count; ndx++)
            {
                if (string.Compare(SeederList[ndx].soldierName, playerInfo.SoldierName) == 0)
                {
                    SeederList[ndx].setOffline();
                    SeederList[ndx].setInactive();
                    SeederList[ndx].teamid = 0;
                    writeMsgToPluginConsole(3, string.Format("Seeder {0} set to offline", SeederList[ndx].soldierName));
                }
            }
        }
        public void OnServerInfo(CServerInfo csiServerInfo)
        {
            string strcurrentGametype = csiServerInfo.GameMode.ToLower();
            if (strcurrentGametype.Contains("rush"))
            {
                rush_mode_flag = true;
            }
            else
            {
                rush_mode_flag = false;
            }

            team1Score = csiServerInfo.TeamScores[0].Score;
            team2Score = csiServerInfo.TeamScores[1].Score;
            team1_minus_team2_score = team1Score - team2Score;
            writeMsgToPluginConsole(5, string.Format("Updating team scores.  Team 1 Score: {0}, Team 2 Score:{1}", team1Score, team2Score));

        }


        public void balanceIfNeeded(List<CPlayerInfo> players)
        {

            if (rush_mode_flag == true)
            {
                // rush mode, preference is to have any odd-numbered seeders on the defender side (team2)
                if (team2InactiveSeederCount > (team1InactiveSeederCount + 1))  // if team2 (defenders) has a difference of more than 1, move seeders to attackers (team 1)
                {
                    writeMsgToPluginConsole(1, " Rush mode - detected too many seeders on defender side (team2)");
                    moveOneSeeder(2, 1);           // moveSeeders (int fromTeam, int toTeam, int numSeedersToMove)
                }
                if (team1InactiveSeederCount > team2InactiveSeederCount)      // if team1 (attackers) has more seeders than defenders, move them till equal or defenders has one more
                {
                    writeMsgToPluginConsole(1, " Rush mode - detected too many seeders on attackers side (team1)");
                    moveOneSeeder(1, 2);
                }
            }
            else
            {
                // if code gets to here, this is not rush mode
                writeMsgToPluginConsole(3, string.Format("Mode is NOT rush.  Using balanceMethod: {0}", balanceMethod));

                if (balanceMethod == 1)        // player count method
                {
                    if (team1_minus_team2_inactiveSeederCount < -1) { moveOneSeeder(2, 1); }   // too many seeders on team 2, move one to team 1
                    if ((team1_minus_team2_inactiveSeederCount == -1) && (team1_minus_team2_realPlayerCount > 1)) { moveOneSeeder(2, 1); }   // extra seeder on team 2, team 2 disadvantaged, move a seeder to team 1
                    if ((team1_minus_team2_inactiveSeederCount == 1) && (team1_minus_team2_realPlayerCount < -1)) { moveOneSeeder(1, 2); }    // team1 has extra seeder and is disadvantaged, move a seeder to team 2
                    if (team1_minus_team2_inactiveSeederCount > 1) { moveOneSeeder(1, 2); }       // team 1 has too many seeders, move one to team2
                }
                if (balanceMethod == 2)        // ticket count method
                {
                    if (team1_minus_team2_inactiveSeederCount < -1) { moveOneSeeder(2, 1); }  // too many seeders on team 2, move one to team 1
                    if ((team1_minus_team2_inactiveSeederCount == -1) && (team1_minus_team2_score > 0)) { moveOneSeeder(2, 1); } // extra seeder on team 2, team 2 disadvantaged, move a seeder to team 1
                    if ((team1_minus_team2_inactiveSeederCount == 1) && (team1_minus_team2_score < 0)) { moveOneSeeder(1, 2); }     // team1 has extra seeder and is disadvantaged, move a seeder to team 2
                    if (team1_minus_team2_inactiveSeederCount > 1) { moveOneSeeder(1, 2); }     // team 1 has too many seeders, move one to team2
                }
            }
        }
        

        private void moveOneSeeder(int moveFromTeam, int moveToTeam)
        {
            // move one seeder from  moveFromTeam to moveToTeam
            for (int i = 0; i < SeederList.Count; i++)
            {
                writeMsgToPluginConsole(1, string.Format("Checking seeders: {0}", SeederList[i].soldierName));

                if ((SeederList[i].teamid == moveFromTeam) && (SeederList[i].checkIsActive() == false))     // find an inactive seeder on the movefromTeam
                {
                    this.ExecuteCommand("procon.protected.send", "admin.movePlayer", SeederList[i].soldierName, Convert.ToString(moveToTeam), "0", "true");
                    writeMsgToPluginConsole(1, string.Format("Moving seeder {0} from Team {1} to Team {2}", SeederList[i].soldierName, moveFromTeam, moveToTeam));
                    return;
                }
                else
                {
                    writeMsgToPluginConsole(5, string.Format("Seeder {0} is either not online and active or is on wrong team, not moving.", SeederList[i].soldierName));

                }
            }

        }


        public void writeMsgToPluginConsole(int debugLevel, string message)
        {
            if (debugLevel <= debugPrintLevel)
            {
                this.ExecuteCommand("procon.protected.pluginconsole.write", string.Format("BalanceServerSeeders: {0}", message));
            }
        }

        public override void OnListPlayers(List<CPlayerInfo> players, CPlayerSubset cpsSubset)
        {
    
            if (cpsSubset.Subset != CPlayerSubset.PlayerSubsetType.All)
            {
                writeMsgToPluginConsole(5, string.Format("OnlistPlayer triggered but not full list {0}", cpsSubset));
                return;      // if we didn't get the full list, do nothing
            }

            writeMsgToPluginConsole(4, string.Format("Player count {0}", players.Count));

            
            

           // loop through each seeder, check and see if seeder is online and update the seederlist with his current info
            for (int ndxSeeder = 0; ndxSeeder < SeederList.Count; ndxSeeder++)
            {
                // set all seeders to offline, team 0, and inactive and let them get set to current values by the updated player list if a match is found
                SeederList[ndxSeeder].setOffline();
                SeederList[ndxSeeder].setInactive();
                SeederList[ndxSeeder].teamid = 0;

                // loop through each player listed from the server
                for (int ndxPlayer = 0; ndxPlayer < players.Count; ndxPlayer++)
                {
                    // if the playername matches a seeder, update score, online status
                    if (string.Compare(players[ndxPlayer].SoldierName, SeederList[ndxSeeder].soldierName) == 0)
                    {
                        SeederList[ndxSeeder].setOnline();
                        SeederList[ndxSeeder].updateScore(players[ndxPlayer].Score);
                        SeederList[ndxSeeder].teamid = players[ndxPlayer].TeamID;

                        StringBuilder outputString = new StringBuilder(string.Format("Seeder: {0}", SeederList[ndxSeeder].soldierName));
                        outputString.Append(string.Format("Team: {0}, Current Score: {1},", players[ndxPlayer].TeamID, players[ndxPlayer].Score));

                        double minutesSinceScore = SeederList[ndxSeeder].getMinutesSinceLastScoreIncrease();
                        outputString.Append(string.Format("Minutes since last score increase: {0},", minutesSinceScore));
                        if (minutesSinceScore > time_since_score)
                        {
                            SeederList[ndxSeeder].setInactive();
                            outputString.Append(string.Format(", status: Inactive"));
                        }
                        else
                        {
                            SeederList[ndxSeeder].setActive();
                            outputString.Append(string.Format(", status: Active"));
                        }

                        writeMsgToPluginConsole(3, outputString.ToString());
                    }
                }
            }


            // count the total players on each team
            team1count = 0;
            team2count = 0;
            for (int ndxPlayer = 0; ndxPlayer < players.Count; ndxPlayer++)
            {
                if (players[ndxPlayer].TeamID == 1) { team1count++; }
                if (players[ndxPlayer].TeamID == 2) { team2count++; }
            }
            
            // count the inactive seeders
            team1InactiveSeederCount = countIdleOnlineSeeders(1);
            team2InactiveSeederCount = countIdleOnlineSeeders(2);

            // count the players that aren't idle seeders
            team1RealPlayerCount = team1count - team1InactiveSeederCount;
            team2RealPlayerCount = team2count - team1InactiveSeederCount;

            team1_minus_team2_inactiveSeederCount = team1InactiveSeederCount - team2InactiveSeederCount;
            team1_minus_team2_realPlayerCount = team1RealPlayerCount - team2RealPlayerCount;


            //this.updateOnlineSeedersActivityStatus();
            this.balanceIfNeeded(players);
        }
    }
}